Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sourceforge.pmd.stat
Class StatisticalRule

    java.lang.Object
      net.sourceforge.pmd.ast.JavaParserVisitorAdapter
          net.sourceforge.pmd.AbstractRule
              net.sourceforge.pmd.stat.StatisticalRule

All Implemented Interfaces:
  JavaParserVisitor, Rule

Direct Known Subclasses:
  AbstractNcssCount, ExcessiveLengthRule, ExcessiveNodeCountRule, NpathComplexity, SwitchDensityRule

public abstract class StatisticalRule
extends AbstractRule

Author:
  David Dixon-Peugh Aug 8, 2002 StatisticalRule.java

Field Summary
`static double` | `DELTA`

Fields inherited from class net.sourceforge.pmd.AbstractRule
`description, example, externalInfoUrl, include, message, name, priority, properties, ruleSetName, usesDFA, usesTypeResolution`

Fields inherited from interface net.sourceforge.pmd.Rule
`LOWEST_PRIORITY, PRIORITIES`

Constructor Summary
`StatisticalRule()`

Method Summary
`void` | `addDataPoint(DataPoint point)`
`void` | `apply(java.util.List acus, RuleContext ctx)`
`protected java.util.SortedSet` | `applyMinimumValue(java.util.SortedSet pointSet, double minValue)`
`protected java.util.SortedSet` | `applyTopScore(java.util.SortedSet points, int topScore)`
`protected double` | `getMean()`
`protected double` | `getStdDev()`
`protected void` | `makeViolations(RuleContext ctx, java.util.Set p)`
`protected java.util.Map` | `propertiesByName()` Return all the relevant properties for the receiver by overriding in subclasses as necessary.

Methods inherited from class net.sourceforge.pmd.AbstractRule
`addProperties, addProperty, addViolation, addViolation, addViolation, addViolationWithMessage, asFixedMap, asFixedMap, equals, getBooleanProperties, getBooleanProperty, getBooleanProperty, getDeclaringType, getDescription, getDoubleProperties, getDoubleProperty, getDoubleProperty, getExample, getExternalInfoUrl, getIntProperties, getIntProperty, getIntProperty, getMessage, getName, getPriority, getPriorityName, getProperties, getRuleSetName, getStringProperties, getStringProperty, getStringProperty, getTypeProperties, getTypeProperty, hashCode, hasProperty, importsPackage, include, isQualifiedName, propertyDescriptorFor, setBooleanProperty, setDescription, setExample, setExternalInfoUrl, setInclude, setMessage, setName, setPriority, setProperties, setProperty, setRuleSetName, setUsesDFA, setUsesTypeResolution, usesDFA, usesTypeResolution, visitAll`

Methods inherited from class net.sourceforge.pmd.ast.JavaParserVisitorAdapter
`visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DELTA

    public static double DELTA

Constructor Detail

### StatisticalRule

    public StatisticalRule()

Method Detail

### addDataPoint

    public void addDataPoint(DataPoint point)

### apply

    public void apply(java.util.List acus,
                      RuleContext ctx)

  Specified by:
    `apply` in interface `Rule`
  Overrides:
    `apply` in class `AbstractRule`

### getMean

    protected double getMean()

### getStdDev

    protected double getStdDev()

### applyMinimumValue

    protected java.util.SortedSet applyMinimumValue(java.util.SortedSet pointSet,
                                                    double minValue)

### applyTopScore

    protected java.util.SortedSet applyTopScore(java.util.SortedSet points,
                                                int topScore)

### makeViolations

    protected void makeViolations(RuleContext ctx,
                                  java.util.Set p)

### propertiesByName

    protected java.util.Map propertiesByName()

  Description copied from class: `AbstractRule`
  Return all the relevant properties for the receiver by overriding in subclasses as necessary.

  Overrides:
    `propertiesByName` in class `AbstractRule`
  Returns:
    Map

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2006 InfoEther. All Rights Reserved.